<?
@extract($HTTP_POST_VARS); 
@extract($HTTP_GET_VARS);

// p~bV א  c . drwxrwxrwx
function get_perms($mode)
{
    /* Determine Type */
    if( $mode & 0x1000 )
        $perms["type"] = 'p'; /* FIFO pipe */
    else if( $mode & 0x2000 )
        $perms["type"] = 'c'; /* Character special */
    else if( $mode & 0x4000 )
        $perms["type"] = 'd'; /* Directory */
    else if( $mode & 0x6000 )
        $perms["type"] = 'b'; /* Block special */
    else if( $mode & 0x8000 )
        $perms["type"] = '-'; /* Regular */
    else if( $mode & 0xA000 )
        $perms["type"] = 'l'; /* Symbolic Link */
    else if( $mode & 0xC000 )
        $perms["type"] = 's'; /* Socket */
    else
        $perms["type"] = 'u'; /* UNKNOWN */

    /* Determine permissions */
    $perms["owner_read"]    = ($mode & 00400) ? 'r' : '-';
    $perms["owner_write"]   = ($mode & 00200) ? 'w' : '-';
    $perms["owner_execute"] = ($mode & 00100) ? 'x' : '-';
    $perms["group_read"]    = ($mode & 00040) ? 'r' : '-';
    $perms["group_write"]   = ($mode & 00020) ? 'w' : '-';
    $perms["group_execute"] = ($mode & 00010) ? 'x' : '-';
    $perms["world_read"]    = ($mode & 00004) ? 'r' : '-';
    $perms["world_write"]   = ($mode & 00002) ? 'w' : '-';
    $perms["world_execute"] = ($mode & 00001) ? 'x' : '-';

    /* Adjust for SUID, SGID and sticky bit */
    if( $mode & 0x800 )
        $perms["owner_execute"] = ($perms["owner_execute"]=='x') ? 's' : 'S';
    if( $mode & 0x400 )
        $perms["group_execute"] = ($perms["group_execute"]=='x') ? 's' : 'S';
    if( $mode & 0x200 )
        $perms["world_execute"] = ($perms["world_execute"]=='x') ? 't' : 'T';

    return $perms;
}

if (file_exists("../dbconfig.php")) {
    header("location:./");
    exit;
}

$perms = get_perms(fileperms("../"));
if ($perms["world_read"].$perms["world_write"].$perms["world_execute"] != "rwx") {
    echo "
    <title>ʃ{[h : ݒu : p~bV ݒ</title>
    <p><span style='font-size:10pt; font-family:Verdana, MSSVbN;'>
    ʃ{[h vOݒu܂B
    <p>tH_ p~bV 707  ݒ肵ĂB
    <p><p>chmod 707 qgnuboard directoryr
    <p><p>܂ ʃ{[h tH_ɂ chmod 707 .
    <p>ݒ肵 XV(F5) ĂB</span><p>";
    exit;
}

header("location:./installadmin.php");
?>
