<?
if (defined(__FILE__)) return;
define(__FILE__, TRUE);

//==============================================================================
//  v  s
//==============================================================================


// Ɏ  C
function set_search_font($stext, $str)
{
    return str_replace($stext, "__SEARCH_FONT_BEGIN__{$stext}__SEARCH_FONT_END__", $str);
}


// Cg Ɏ   
function get_search_font($str) {
    global $default;

    $source = array("/__SEARCH_FONT_BEGIN__/", "/__SEARCH_FONT_END__/");
    $target = array("<span style='background-color:$default[de_search_bgcolor]'><font color='$default[de_search_color]'>", "</font></span>");
    return preg_replace($source, $target, $str);
}


// E 
function conv_subject($subject, $len, $suffix="")
{
    global $sselect, $stext, $soperator;

    $s = explode(" ", $stext);

    $subject = cut_str(get_text($subject), $len, $suffix);
    for ($m=0; $m<count($s); $m++) {
        if ($stext && preg_match("/wr_subject/", $sselect)) {
            $subject = set_search_font($s[$m], $subject);
        }
    }
    $subject = get_search_font($subject);

    return $subject;
}


// Z 
function conv_content($content, $html)
{
    global $cfg, $sselect, $stext, $soperator;

    if ($html) {    // html ʌ
        if (!$cfg[script_use]) {
            $source = array ( "/<script/i", "/<\/script/i", "/javascript:/i", "/http-equiv/i" );
            $target = array ( "<x-script",  "</x-script",   "x-javascript:",  "x-http-equiv"  ); 
        } else {
            $source[] = "//";
            $target[] = "";
        }

        if ($html == 2) { // ؋^ xx
            $source[] = "/\n/";
            $target[] = "<br>";
        }

        $content = preg_replace($source, $target, $content);
    } else {    // text ʌ
        $s = explode(" ", $stext);

        $content = get_text($content, 1);
        for ($m=0; $m<count($s); $m++) {
            if ($stext && preg_match("/wr_content/", $sselect)) {
                $content = set_search_font($s[$m], $content);
            }
        }
        $content = get_search_font($content);

        $content = urlautolink($content);
    }

    return $content;
}


// Ɏ WM .
function get_sql_search($field, $stext, $soperator=0)
{
    $op = "";
    $str = " and ( ";
    // Ɏ쌤 Wΐ،m I. H 
    $s = explode(" ", $stext);
    for ($i=0; $i<count($s); $i++) {
        $str .= " $op ";
        switch ($field) {
            case "wr_subject|wr_content" :
                $str .= " (wr_subject like '%$s[$i]%' or wr_content like '%$s[$i]%') ";
                break;
            case "ca_id" :
                $str .= " ($field = '$s[$i]') ";
                break;
            case "wr_hit" :
            case "wr_good" :
            case "wr_nogood" :
                $str .= " ($field >= '$s[$i]') ";
                break;
            case "wr_num" :
                $str .= " ($field = ".((-1)*$s[$i]).") ";
                break;
            default :
                $str .= " ($field like '%$s[$i]%') ";
                break;
        }
        $op = ($soperator) ? " and " : " or ";
    }
    $str .= " ) ";

    return $str;
}


// ҏb vʍ@ nI  ΐ
function get_write($write, $wr_id)
{
    return sql_fetch(" select * from $write where wr_id = '$wr_id' ");
}


// v C vʍ@ nI  ΐ
function get_group($gr_id)
{
    global $cfg;
    return sql_fetch(" select * from $cfg[table_group] where gr_id = '$gr_id' ");
}


// Wn ҏbŐ̈?
function is_board($table)
{
    global $cfg;

    $is = false;
    $result = mysql_list_tables($cfg[mysql_db]);
    for ($i=0; $i<mysql_num_rows($result); $i++) {
        if ($table == mysql_tablename($result, $i)) {
            $resultfield = mysql_list_fields($cfg[mysql_db], $table);
            // vʍ X i wr_id ʌ ҏb vʍʊ.
            if (mysql_field_name($resultfield, 0) == "wr_id") {
                $is = true;
                break;
            }
        }
    }

    return $is;
}


//  C .
function get_member($mb_id)
{
    global $cfg;

    $sql = " select * from $cfg[table_member]
              where mb_id = TRIM('$mb_id') ";
    return sql_fetch($sql);
}


// Em R Ccn QUERY STRING
function subject_sort_link($col, $query_string='')
{
    global $ssort, $sorder, $sselect, $stext, $page, $doc;
    global $HTTP_SERVER_VARS;

    $q1 = "ssort=$col";
    $q2 = "sorder=asc";
    if ($ssort == $col) {
        if ($sorder == "asc") {
            $q2 = "sorder=desc";
        }
    }
    return "<a href='./?doc=$doc&$q1&$q2&sselect=$sselect&stext=$stext&page=$page&$query_string'>";
}


// ؐ̑ Ɏ
function get_admin($admin='default')
{
    global $cfg, $default, $group, $board;

    $is = false;
    if ($admin == 'board') {
        $mb = sql_fetch("select * from $cfg[table_member] where mb_id = '$board[bo_admin]'");
        $is = true;
    }

    if (($is && !$mb[0]) || $admin == 'group') {
        $mb = sql_fetch("select * from $cfg[table_member] where mb_id = '$group[gr_admin]'");
        $is = true;
    }

    if (($is && !$mb[0]) || $admin == 'default') {
        $mb = sql_fetch("select * from $cfg[table_member] where mb_id = '$default[de_admin]'");
    }

    return $mb;
}


// ؐ̈?
function is_admin($mb_id)
{
    global $default, $cfg;

    $is = '';
    if ($mb_id) {
        if ($default[de_admin] == $mb_id) {
            $is = 'default';
        } else {
            $sql = " select count(*) from $cfg[table_group] where gr_admin = '$mb_id' ";
            $row = sql_fetch($sql);
            if ($row[0] > 0) {
                $is = 'group';
            } else {
                $sql = " select count(*) from $cfg[table_board] where bo_admin = '$mb_id' ";
                $row = sql_fetch($sql);
                if ($row[0] > 0) {
                    $is = 'board';
                }
            }
        }
    }

    return $is;
}


// Ό hŐ 
function get_category_option($table)
{
    global $cfg;

    $sql = " select * from {$table}_cat order by ca_id ";
    $result = sql_query($sql);
    $str = "";
    while ($row = mysql_fetch_array($result)) {
        $str .= "<option value='$row[ca_id]'>$row[ca_name]</option>\n";
    }
    mysql_free_result($result);

    return $str;
}


function get_category_name($table, $ca_id)
{
    global $cfg;

    $sql = " select ca_name from {$table}_cat where ca_id = '$ca_id' ";
    $row = sql_fetch($sql);
    return $row[0];
}


// il
function check_filter($content)
{
    global $default;

    $filter = $default[de_filter];

    $is_bad = false;
    $pattern = explode(",", $filter);
    for ($i=0; $i<count($pattern); $i++) {
        $pattern[$i] = trim($pattern[$i]);
        if ($pattern[$i] == "") {
            continue;
        }
        $pat = "/{$pattern[$i]}/i";
        $is_bad = @preg_match($pat, $content);
        if ($is_bad) {
            break;
        }
    }

    return $is_bad;
}


// IP 
function check_intercept_ip()
{
    global $cfg, $HTTP_SERVER_VARS;

    $is_bad = false;
    $pattern = explode(",", trim($default[de_intercept_ip]));
    for ($i=0; $i<count($pattern); $i++) {
        $pattern[$i] = trim($pattern[$i]);
        if ($pattern[$i] == "") {
            continue;
        }
        $pat = "/^({$pattern[$i]})/";
        $is_bad = preg_match($pat, $HTTP_SERVER_VARS[REMOTE_ADDR]);
        if ($is_bad)
            break;
    }

    return $is_bad;
}


function get_level_select($name, $selected='1', $event='')
{
    global $cfg;

    $str = "<select name='$name' $event>";
    for ($i=$cfg[level_guest]; $i<=$cfg[level_max]; $i++) {
        $str .= "<option value='$i'";
        if ($i == $selected) {
            $str .= " selected ";
        }
        $str .= ">$i</option>";
    }
    $str .= "</select>";
    return $str;
}


function get_yn_select($name, $selected='1', $event='')
{
    $str = "<select name='$name' $event>";
    if ($selected) {
        $str .= "<option value='1' selected>͂</option>";
        $str .= "<option value='0'></option>";
    } else {
        $str .= "<option value='1'>͂</option>";
        $str .= "<option value='0' selected></option>";
    }
    $str .= "</select>";
    return $str;
}


function insert_point($mb_id, $point, $content='')
{
    global $cfg, $default, $today, $now;

    // ̓ ׌ Dʓ q i 
    if ($point == 0) { return; }
    // Đʋ ׌ Dʓ q i 
    if ($mb_id == "") { return; }

    $sql = " select mb_today_point from $cfg[table_member]
              where mb_id = '$mb_id'
               and TO_DAYS('$today') - TO_DAYS(mb_today_login) = 0 ";
    $row = sql_fetch($sql);
    $today_point = $row[mb_today_point];

    // n  ̓ وÊI Jp ʋ(C 0ʋ)
    if ($today_point < $default[de_day_max_point] || $default[de_day_max_point] == 0) {
        // ̓ 
        $sql = " update $cfg[table_member]
                    set mb_today_point = mb_today_point + ($point),
                        mb_point = mb_point + ($point)
                  where mb_id = '$mb_id' ";
        sql_query($sql);

        // ̓ ō 
        $sql = " insert $cfg[table_point]
                    set mb_id = '$mb_id',
                        po_datetime = '$now',
                        po_content = '$content',
                        po_point = '$point' ";
        sql_query($sql);
    }
}


// ҏbŐ אz  .
function get_next_num($table, $notice=0)
{
    // v 䐌 v@  ِ  
    if ($notice == -1) {
        $sql1 = " select min(wr_num) from $table where wr_notice = '-1' ";
        $row1 = sql_fetch($sql1);
    }

    // v Ċωz@  ِ  
    $sql2 = " select min(wr_num) from $table where wr_notice = '0' ";
    $row2 = sql_fetch($sql2);

    // RnH ِ @ 1 J  |
    if ((int)$row1[0] < (int)$row2[0]) {
        return ((int)$row1[0] - 1);
    } else {
        return ((int)$row2[0] - 1);
    }
}


// @ q   av ׌ ʌ avm 
function convert_signature($signature)
{
    $source[] = "<script";
    $source[] = "</script";
    $target[] = "<x-script";
    $target[] = "</x-script";

    return str_replace($source, $target, $signature);
}


// mv  
function get_login_count($kind='total')
{
    global $cfg;
    $fr_time = date("Y-m-d H:i:s", time() - (60 * $cfg[login_minutes]));
    $to_time = date("Y-m-d H:i:s", time());
    $sql = " select count(lo_ip) from $cfg[table_login]
              where lo_datetime between '$fr_time' and '$to_time' ";
    if ($kind == 'total')
        $sql .= "";
    else if ($kind == 'member')
        $sql .= " and mb_id != '' ";
    else if ($kind == 'guest')
        $sql .= " and mb_id = '' ";
    $row = sql_fetch($sql);
    return $row[0];
}


// ȑ Xʏ
function gblayer($mb_id, $name='', $email='', $homepage='', $open=0)
{
    global $cfg;
    static $layerno = 0;

    $layerno++;
    
    $email = preg_replace("/@/", "&#064;", $email);
    $homepage = set_http($homepage);
    $profile = 0;

    $str = "<span onmousedown=\"gblayeraction('gblayer{$layerno}')\" style='cursor:hand;'>";
    if ($mb_id) {
        $icon_file = "./data/member/$mb_id.gif";
        if (file_exists($icon_file) && is_file($icon_file)) {
            $size = getimagesize($icon_file);
            $width = $size[0];
            $height = $size[1];
            if ($width > $cfg[mb_icon_width]) {
                $width = $cfg[mb_icon_width];
            }
            if ($height > $cfg[mb_icon_height]) {
                $height = $cfg[mb_icon_height];
            }
            $str .= "<img src='$icon_file' width='$width' height='$height' align=absbottom> ";
        }
        $str .= "<b>$name</b>";
        // C 
        if (!$open) {
            $mb_id = "";
            $email = "";
            $homepage = "";
        } else {
            $profile = 1;
        }

    } else {
        $str .= $name;
    }
    $str .= "</span>";
    $str .= "<script language='JavaScript'>gblayer('gblayer{$layerno}', '{$mb_id}', '{$name}', '{$email}', '{$homepage}', '{$profile}', './bbs');</script>";
    return $str;
}


// ͐ ʈ n H (ʍk, b@K, ^T)
function view_file_link($file)
{
    global $cfg, $board;

    if (!$file) return;

    $size = @getimagesize("./data/file/$board[bo_table]/$file");
    $source_width  = $size[0];
    $source_height = $size[1];

    if ($board[bo_table_width] <= 100) {
        if ($size[0] > $cfg[large_image_size]) {
            $rate = $size[1] / $size[0];
            $size[0] = $cfg[large_image_size];
            $size[1] = (int)($size[0] * $rate);
        }
    } else {
        if ($size[0] > $board[bo_table_width]) {
            $rate = $size[1] / $size[0];
            $size[0] = $board[bo_table_width];
            $size[1] = (int)($size[0] * $rate);
        }
    }

    $width  = $size[0];
    $height = $size[1];

    if (preg_match($cfg[image_extension], $file))
        return "<img src='./data/file/$board[bo_table]/$file' width='$width' height='$height' border=0><p>";
    else if (preg_match($cfg[flash_extension], $file))
        return "<embed src='./data/file/$board[bo_table]/$file' width='$width' height='$height'></embed><p>";
    else if (preg_match($cfg[movie_extension], $file))
        return "<embed src='./data/file/$board[bo_table]/$file'></embed><p>";
}


function get_yn($val, $case='')
{
    switch ($case) {
        case '1' : $result = ($val > 0) ? 'Y' : 'N'; break;
        default :  $result = ($val > 0) ? '͂' : '';
    }
    return $result;
}
?>
